#include <MacHeaders>

typedef struct
{	TMTask **myTaskHdl;
	long tmOverhead;
	char myPackState;
} myDataRec, *myDataPtr, **myDataHdl;

#define GLOBALPTR (**Data)

#define MSLIMIT 60000000	/* ~ <18 hours in milliseconds */
#define USLIMIT 30000000	/* 30 seconds in microseconds */

pascal main(ProcNum, PtrList, Data, FuncReturn)
long ProcNum;
long **PtrList;
myDataHdl *Data;
long *FuncReturn;

{	TMTask *TaskPtr;

	switch (ProcNum)
  	{	case -1: 	*Data = (myDataHdl)NewHandle(sizeof(myDataRec));
  					GLOBALPTR->myTaskHdl = (TMTask **)NewHandle(sizeof(TMTask));
  					MoveHHi(GLOBALPTR->myTaskHdl);
  					HLock(GLOBALPTR->myTaskHdl);
  					GLOBALPTR->myPackState = 0; /* 0 for no timer, 1 for ms, 2 for us */
    		 		break;
    		 
    	case -2: 	if(GLOBALPTR->myPackState)
    				{	RmvTime(TaskPtr);
    					HUnlock(GLOBALPTR->myTaskHdl);
    					DisposeHandle(GLOBALPTR->myTaskHdl);
    				}
    				DisposHandle(*Data);
    		 		break;
    		 
   		case 1:		/* Start Millisecond Timer */
   					TaskPtr = *GLOBALPTR->myTaskHdl;
   					if (GLOBALPTR->myPackState)
   						RmvTime(TaskPtr);
   					TaskPtr->tmAddr = 0;
   					TaskPtr->tmWakeUp = 0;
   					TaskPtr->tmReserved = 0;
   					InsTime(TaskPtr);
   					PrimeTime(TaskPtr,MSLIMIT); 
   					RmvTime(TaskPtr);
   					GLOBALPTR->tmOverhead = MSLIMIT - TaskPtr->tmCount;
   					/* *FuncReturn = GLOBALPTR->tmOverhead; */
   					GLOBALPTR->myPackState = 1;
   					InsTime(TaskPtr);
   					PrimeTime(TaskPtr,MSLIMIT); 
   					break;
   				
   		case 2:		/* Start Microsecond Timer */
   					TaskPtr = *GLOBALPTR->myTaskHdl;
   					if (GLOBALPTR->myPackState)
   						RmvTime(TaskPtr);
   					TaskPtr->tmAddr = 0;
   					TaskPtr->tmWakeUp = 0;
   					TaskPtr->tmReserved = 0;
   					InsTime(TaskPtr);
   					PrimeTime(TaskPtr,-USLIMIT); 
   					RmvTime(TaskPtr);
   					GLOBALPTR->tmOverhead = USLIMIT + TaskPtr->tmCount; /* remember, it's negative */
   					/* *FuncReturn = GLOBALPTR->tmOverhead; */
   					GLOBALPTR->myPackState = 2;
   					InsTime(TaskPtr);
   					PrimeTime(TaskPtr,-USLIMIT); 
   					break;
   				
		case 3:		/* Get Time */
   					TaskPtr = *GLOBALPTR->myTaskHdl;
					switch (GLOBALPTR->myPackState)
					{	case 0:		/* no timing task inititiated */
									*FuncReturn = 0;
									break;
									
						case 1:		/* millisecond timer running */
									RmvTime(TaskPtr);
									if (TaskPtr->tmCount) /* time remaining */
										*FuncReturn = MSLIMIT - TaskPtr->tmCount - GLOBALPTR->tmOverhead;
									else *FuncReturn = 0;
  									GLOBALPTR->myPackState = 0;
									break;
									
						case 2:		/* microsecond timer running */
									RmvTime(TaskPtr);
									if (TaskPtr->tmCount) /* time remaining */
										*FuncReturn = USLIMIT + TaskPtr->tmCount - GLOBALPTR->tmOverhead;
									else *FuncReturn = 0;
  									GLOBALPTR->myPackState = 0;
									break;
					}
  }
}
