/*
# Copyright Department of Computer Science
# University of Western Australia
# Created : Quinn
# Station : Eriodon
# Date : Tuesday, 13 October 1992
# From : LMGlue.p Rev 11

	The canonical LabMaster interface is defined in Pascal.  These headers have not
	been thoroughly tested.  If there is a conflict between these headers and the
	Pascal interfaces, the Pascal should take precedence.
*/

/* ///////////////////////////////////////////////////////////////////////////////// */

#ifndef __LMGLUE__
#define __LMGLUE__

#ifndef __TYPES__
#include <Types.h>
#endif

#ifndef __FILES__
#include <Files.h>
#endif

#ifndef __APPLETALK__
#include <AppleTalk.h>
#endif

#ifndef __LMTYPES__
#include "LMTypes.h"
#endif

/* ///////////////////////////////////////////////////////////////////////////////// */

enum {
	bad_grefnum = 32767
};

#ifdef __cplusplus
extern "C" {
#endif

pascal OSErr GetLMRefNum(short *grefnum);

pascal OSErr LMGestalt(short grefnum, OSType selector, long *result);

pascal OSErr RegisterCapabilities(short grefnum, addrIdent addr, capHandle caps,
																		long refcon, Ptr a5world);
pascal OSErr DeregisterCapabilities(short grefnum, addrIdent addr);

pascal OSErr SetCapTime(short grefnum, addrIdent addr, long deltat);

pascal OSErr SendMessage(short grefnum, messagePtr msg);

#ifdef gofStreams

pascal OSErr StreamOpenPassive(short grefnum, addrIdent addr,
																streamAddr *port, streamRef *strm);
pascal OSErr StreamOpenActive(short grefnum, addrIdent addr,
																const streamAddr *port, streamRef *strm);										
pascal OSErr StreamClose(short grefnum, streamRef strm);
pascal OSErr StreamRead(short grefnum, streamRef strm, Ptr buf, long size);
pascal OSErr StreamWrite(short grefnum, streamRef strm, Ptr buf, long size);
pascal OSErr StreamStatus(short grefnum, streamRef strm, streamInfo *inf);

#endif

#ifdef gofHotCalls

pascal OSErr HotInstallModule(short grefnum, const FSSpec *fss, modIdent *themod);
pascal OSErr HotRemoveModule(short grefnum, modIdent themod);

#endif

#ifdef gofDriverInfo

pascal OSErr GetModuleCount(short grefnum, short *nummods);
pascal OSErr GetIndModule(short grefnum, short index, modIdent *amod);
pascal OSErr GetModuleInfo(short grefnum, modIdent themod, short version, modInfo *inf);

pascal OSErr GetAddressCount(short grefnum, short *numaddr);
pascal OSErr GetIndAddress(short grefnum, short index, addrIdent *addr);
pascal OSErr GetAddressInfo(short grefnum, addrIdent, short version, addrInfo *inf);

pascal OSErr GetCapabilityCount(short grefnum, addrIdent addr, short *numcaps);
pascal OSErr GetIndCapability(short grefnum, addrIdent addr, short index, capIdent *cap);
pascal OSErr GetCapabilityInfo(short grefnum, addrIdent add, capIdent cap, short version, capInfo *inf);

#endif

#ifdef gofClientInfo

/* The Client and Server Information interfaces are now obsolete and subsumed by
		the Machine Information Interface.  DO NOT USE THEM!
*/

pascal OSErr GetClientCount(short grefnum, short *numclients);
pascal OSErr GetIndClient(short grefnum, short index, machIdent *mach);
pascal OSErr GetClientInfo(short grefnum, machIdent mach, machInfo *inf);

#endif

#ifdef gofServerInfo

/* The Client and Server Information interfaces are now obsolete and subsumed by
		the Machine Information Interface.  DO NOT USE THEM!
*/

pascal OSErr GetServerCount(short grefnum, short *numserv);
pascal OSErr GetIndServer(short grefnum, short index, machIdent *mach);
pascal OSErr GetServerInfo(short grefnum, machIdent mach, machInfo *inf);

#endif

#ifdef gofMachineInfo

pascal OSErr GetMachineCount(short grefnum, short *nummach);
pascal OSErr GetIndMachine(short grefnum, short index, machIdent *mach);
pascal OSErr GetMachineInfo(short grefnum, machIdent mach, short version, machineInfo *inf);

#endif

#ifdef gofSecure

pascal OSErr SendSecureMessage(short grefnum, messagePtr msg);
pascal OSErr SetKey(short grefnum, const cipherBlock *newkey, long keylife);

#endif

#ifdef __cplusplus
}
#endif

#endif

