/*
# Copyright Department of Computer Science
# University of Western Australia
# Created : Quinn
# Station : Eriodon
# Date : Tuesday, 13 October 1992
# From : LMModuleSubs.p Rev 8

	The canonical LabMaster interface is defined in Pascal.  These headers have not
	been thoroughly tested.  If there is a conflict between these headers and the
	Pascal interfaces, the Pascal should take precedence.
*/

/* ///////////////////////////////////////////////////////////////////////////////// */

#ifndef __LMMODULESUBS__
#define __LMMODULESUBS__

#ifndef __TYPES__
#include <Types.h>
#endif

#ifndef __FILES__
#include <Files.h>
#endif

#ifndef __APPLETALK__
#include <AppleTalk.h>
#endif

#ifndef __LMTYPES__
#include "LMTypes.h"
#endif

/* ///////////////////////////////////////////////////////////////////////////////// */

#ifdef __cplusplus
extern "C" {
#endif

pascal void ClearCapabilities(capHandle h);
pascal void AddCapability(capHandle h, capIdent capID, ProcPtr capProcAddr);
pascal OSErr ValidCapabilities(capHandle h);

/* ///////////////////////////////////////////////////////////////////////////////// */

pascal capIdent BuildMesgID(mesgIdent id)
= {
		0x3F5F, 0x0002,			/* move.w (sp)+, 2(sp)	*/
		0x3EBC, 0x6D65			/* move.w #'me', (sp)		*/
	};

pascal capIdent BuildSecureMesgID(mesgIdent id)
= {
		0x3F5F, 0x0002,			/* move.w (sp)+, 2(sp)	*/
		0x3EBC, 0x736D			/* move.w #'sm', (sp)		*/
	};

pascal capIdent BuildBroadcastID(mesgIdent id)
= {
		0x3F5F, 0x0002,			/* move.w (sp)+, 2(sp)	*/
		0x3EBC, 0x6272			/* move.w #'br', (sp)		*/
	};

pascal capIdent BuildSecureBroadcastID(mesgIdent id)
= {
		0x3F5F, 0x0002,			/* move.w (sp)+, 2(sp)	*/
		0x3EBC, 0x7362			/* move.w #'sb', (sp)		*/
	};

pascal capIdent BuildMesgRetID(mesgIdent id)
= {
		0x3F5F, 0x0002,			/* move.w (sp)+, 2(sp)	*/
		0x3EBC, 0x6D72			/* move.w #'mr', (sp)		*/
	};

pascal mesgIdent StringToMesgIdent(ConstStr255Param s);

pascal Ptr SampleA5()
= {
		0x2E8D							/* move.l	a5,(sp)				*/
	};

/* ///////////////////////////////////////////////////////////////////////////////// */

pascal void RewriteMessage(messagePtr mesg);
pascal void RewriteReply(messagePtr mesg, messagePtr reply);

pascal void AddBytesToMessage(messagePtr mesg, Ptr fromwhere, short n);
pascal void AddByteToMessage(messagePtr mesg, short b);
pascal void AddStringToMessage(messagePtr mesg, Str255 s);
pascal void AddStr32ToMessage(messagePtr mesg, ConstStr32Param s);
pascal void AddBooleanToMessage(messagePtr mesg, Boolean b);
pascal void AddIntegerToMessage(messagePtr mesg, short i);
pascal void AddLongintToMessage(messagePtr mesg, long l);
pascal void AddOSTypeToMessage(messagePtr mesg, OSType ot);
pascal void AddCharToMessage(messagePtr mesg, short ch);

/* NYI pascal OSErr ValidMessage(messagePtr mesg); */

/* ///////////////////////////////////////////////////////////////////////////////// */

pascal void ResetMessage(messagePtr mesg, short *ndx);

pascal OSErr GetBytesFromMessage(messagePtr mesg, short *ndx, Ptr towhere, short n);
pascal OSErr GetByteFromMessage(messagePtr mesg, short *ndx, short *b);
pascal OSErr GetStringFromMessage(messagePtr mesg, short *ndx, Str255 s);
pascal OSErr GetStr32FromMessage(messagePtr mesg, short *ndx, Str32 s);
pascal OSErr GetBooleanFromMessage(messagePtr mesg, short *ndx, Boolean *b);
pascal OSErr GetIntegerFromMessage(messagePtr mesg, short *ndx, short *i);
pascal OSErr GetLongintFromMessage(messagePtr mesg, short *ndx, long *l);
pascal OSErr GetOSTypeFromMessage(messagePtr mesg, short *ndx, OSType *ot);
pascal OSErr GetCharFromMessage(messagePtr mesg, short *ndx, short *ch);

/* NYI pascal OSErr GotAllBytes(messagePtr mesg, short ndx); */

#ifdef __cplusplus
}
#endif

#endif
