/*
# Copyright Department of Computer Science
# University of Western Australia
# Created : Quinn
# Station : Eriodon
# Date : Thursday, 4 November 1993
# From : LMScriptGlue.p Rev 2

	The canonical LabMaster interface is defined in Pascal.  These headers have not
	been thoroughly tested.  If there is a conflict between these headers and the
	Pascal interfaces, the Pascal should take precedence.
*/

/* ///////////////////////////////////////////////////////////////////////////////// */

#ifndef __LMSCRIPTGLUE__
#define __LMSCRIPTGLUE__

#ifndef __TYPES__
#include <Types.h>
#endif

/* ///////////////////////////////////////////////////////////////////////////////// */

enum {
	/* error numbers */
	scriptStartingErr = 2800,		/* script system is starting up */
	sysTooBadErr = 2801,				/* system incapable of using script system */
	noScriptSupportErr = 2802,	/* was gestaltUndefSelectorErr */
	badSessNumErr = 2803,				/* was ahInvalidOpErr */
	wotVarErr = 1008						/* bad variable substitution */
};

enum {
	auto_gen_session = 0
};

typedef long sessionID;

#ifdef __cplusplus
extern "C" {
#endif

pascal OSErr LMSPrime(void);

pascal OSErr LMSGestalt(OSType selector, long * response);

pascal OSErr LMSStartSession(sessionID *snum);
pascal OSErr LMSStopSession(sessionID snum);

pascal OSErr LMSExecuteScript(sessionID snum, Handle source, Handle output,
							ProcPtr lookup, long lookup_refcon,
							ProcPtr idle,   long idle_refcon);
/* 
	pascal OSErr Lookup(long refcon, StringPtr varname, Handle value);
	pascal OSErr Idle(long refcon);
*/

#ifdef __cplusplus
}
#endif

#endif
