unit LMScriptGlue;
(*
# Copyright Department of Computer Science
# University of Western Australia
# Created : Quinn
# Station : Eriodon
# Date : Tuesday, 8 December 1992
*)
interface

{$ifc undefined THINK_Pascal}
	uses
		Types;
{$endc}

	const
		scriptStartingErr = 2800;		(* script system is starting up *)
		sysTooBadErr = 2801;				(* system incapable of using script system *)
		noScriptSupportErr = 2802;	(* was gestaltUndefSelectorErr *)
		badSessNumErr = 2803;				(* was ahInvalidOpErr *)
		wotVarErr = 1008;						(* bad variable substitution *)
		
	const
		auto_gen_session = 0;
	type
		sessionID = longint;

	function LMSPrime : OSErr;
	
	function LMSGestalt(selector : OSType; var response : longint) : OSErr;
	
	function LMSStartSession(var snum : sessionID) : OSErr;
	function LMSStopSession(snum : sessionID) : OSErr;

	function LMSExecuteScript(snum : sessionID; source : Handle; output : Handle;
							lookup : ProcPtr; lookup_refcon : longint;
							idle : ProcPtr; idle_refcon : longint) : OSErr;
	(* 
		lookup points to a function of signature...
			function Lookup(refcon : longint; varname : StringPtr; value : Handle) : OSErr
		The handle is already created, the lookup func should resize it
		 and sets its contents.  If it returns an error code then that
		 error will be returned by DoLMSExecuteScript.  Traditionally the error
		 would be 'wotVarErr' which will also be returned if varname is null.

		idle points to a function of signature...
			function Idle(refcon : longint) : OSErr;
		The idle procedure should yield time to drivers (esp LabMaster).  Errors
		 cause the termination of the script with that error.
		
		If snum is auto_gen_session then start a session, execute the script, stop the
		 session.  output must be a valid handle.
	*)

implementation

	function LMSPrime : OSErr;
		external;
		
	function LMSGestalt(selector : OSType; var response : longint) : OSErr;
		external;
		
	function LMSStartSession(var snum : sessionID) : OSErr;
		external;
	function LMSStopSession(snum : sessionID) : OSErr;
		external;
	
	function LMSExecuteScript(snum : sessionID; source : Handle; output : Handle;
							lookup : ProcPtr; lookup_refcon : longint;
							idle : ProcPtr; idle_refcon : longint) : OSErr;
		external;

end. (* LMScriptGlue *)
