# MPW make file for LabMaster Notify Set
# Copyright Department of Computer Science
# University of Western Australia
# Created : Quinn
# Station : Eriodon
# Date : Wednesday, 16 September 1992
# This file may be freely distributed.

# ----- To Build Notify -----

#   Set LMLibs "{the directory containing LabMaster interfaces and libraries}"
#	Export LMLibs
#   Directory "{the directory containing Notify source code}"
#   BuildProgram Notify

# ---- High Level Targets -----
# List of high level targets in set (in this case there's only one)

Notify  
	NotifyClient

# ---- Override Default Rules ----

.p.o  .p
	{Pascal} {DepDir}{Default}.p 
#		-mbg off 		# uncomment if you want to not see any MacsBugs symbols 
#		-r				# uncomment if you want to suppress range checking 
		-u 				# comment if you don't want data initialisation 
		-i "{LMLibs}"	# look for units in the LMLibs directory 
		-o {TargDir}{Default}.p.o

#  The new default rule simply overrides the original one placing
#   the useful info at the front and setting useful flags globally

# ----- Directory Dependencies -----

:  "{LMLibs}"			# some .o files here are dependent on source in LMLibs
:  :					# and remaining .o files are dependent on source here

# ----- NotifyClient -----

NotifyClient  
		LabMasterModuleHeader.a.o		# glue to ensure proper entry point 
		NotifyTypes.p.o					# types common within set 
		NotifyClient.p.o				# body of module
	Link 
		-o NotifyClient 				# output file name 
		-c Gofa -t GofM					# output file creator and type 
		-rt Gofa=128					# output resource type and ID 
		-m MPWMAIN 						# main entry point 
		-sg NotifyClient				# map all segments to one segment 
		LabMasterModuleHeader.a.o		# must be first to ensure the entry point is correct 
		"{Libraries}"Interface.o		# OS/Toolbox glue 
		NotifyClient.p.o				# body of module 
#		NotifyTypes.p.o					# common stuff (not need for this module) 
		"{LMLibs}"LabMaster.o			# glue for LabMaster (LabMasterDebug.o for debugging)
	

NotifyClient 
	begin
		echo include "NotifyClient.rsrc" not 'ckid';
	end | Rez -a -o NotifyClient -c 'Gofa' -t 'GofM'
	

# End of make file
