# MPW make file for LabMaster Time Set
# Copyright Department of Computer Science
# University of Western Australia
# Created : Quinn
# Station : Eriodon
# Date : Friday, 22 October 1993
# This file may be freely distributed.

# ----- To Build Time -----

#   Set LMLibs "{the directory containing LabMaster interfaces and libraries}"
#	Export LMLibs
#   Directory "{the directory containing Time source code}"
#   BuildProgram Time

# ---- High Level Targets -----
# List of high level targets in set (in this case there's only one)

Time  
	TimeServer

# ---- Override Default Rules ----

.c.o  .c
	{C} {DepDir}{Default}.c 
#		-mbg off 		# uncomment if you want to not see any MacsBugs symbols 
		-r 				# give non-prototype call warnings 
		-i "{LMLibs}"	# look for units in the LMLibs directory 
		-o {TargDir}{Default}.c.o

#  The new default rule simply overrides the original one placing
#   the useful info at the front and setting useful flags globally

# ----- Directory Dependencies -----

:  "{LMLibs}"			# some .o files here are dependent on source in LMLibs
:  :					# and remaining .o files are dependent on source here

# ----- TimeServer -----

TimeServer  
		TimeServer.c.o					# body of module
	Link 
		-o TimeServer	 				# output file name 
		-c Gofa -t GofM					# output file creator and type 
		-rt Gofa=128					# output resource type and ID 
		-m MAIN 						# main entry point (do we need this) 
		-sg TimeServer					# map all segments to one segment 
		TimeServer.c.o					# body of module 
#		"{Libraries}"Interface.o		# OS/Toolbox glue 
		"{LMLibs}"LabMaster.o			# glue for LabMaster
	

TimeServer 
	begin
		echo include "TimeServer..rsrc" not 'ckid';
	end | Rez -a -o TimeServer -c 'Gofa' -t 'GofM'
	

# End of make file
