{ToolBar Manager sample code}
{ Copyright 1993 SNR Enterprises}
{by Narayan Sainaney}
{3480 Carnarvon Avenue,}
{North Vancouver, B.C.,}
{V7N 3K9}
{CANADA}
{Internet: sainaney@unixg.ubc.ca}

{This is a sample usage of the ToolBar Manager. The following code}
{creates a window which holds two toolbars.}

program TBMan;
	uses
		IconSuite, ToolBars;

{NOTE: IconSuite is decribed in APDA Tech note #306.}

	var
		myWindow, theWindow: WindowPtr;	{Main window and dummy window}
		myRGBCol: RGBColor;	{Color to hold background color of the toolbars}
		myTB, myTBII: TBHandle;	{We will be creating 2 toolbars}
		ddomrect, ddomRectII: rect;	{ddom = 'Don't depend on me.' These RECT's change frequently, hence the name}
		mouseLoc, lastLoc: Point;
		theCell, err, curDimcell, thePart: Integer;
		gEvt: EventRecord;
		dummy, dimmed, endit: Boolean;
		cellsArray: array[1..4] of Integer;

begin
	myWindow := GetNewCWindow(128, nil, WindowPtr(-1));

{It is better to create a CWindow as the background color might be a shade of grey (as in this case)}
{which would not shopw up on a B&W window}

	myRGBCol.red := 39321;
	myRGBCol.green := 39321;
	myRGBCol.blue := 39321;

{We define our background colors}

	SetRect(ddomrect, 0, 0, 100, 22);	{Rect for the bar}
	SetRect(ddomrectII, 0, 22, 100, 32);	{Rect for the scroll area}

	myTB := TBCreate(myWindow, ddomrect, ddomRectII, 20, 3, 0, nil, GetPicture(130), GetPicture(129), myRGBCol, blackColor);
{Create a ToolBar with 20, 22 x 22 cells, inset of 3 (hence 16 x 16 icons) }
{Do:}
{ SetRect(ddomrect, 0, 0, 100, 38);	}
{ SetRect(ddomrectII, 0, 38, 100, 48); }
{ and use GetPicture(128) instead of GetPicture (130) to draw a toolbar with 32 x 32 icons}

	SetRect(ddomrect, 101, 0, 240, 22);	{Rect for the bar}
	SetRect(ddomrectII, 101, 22, 240, 32);	{Rect for the scroll area}

	myTBII := TBCreate(myWindow, ddomrect, ddomRectII, 8, 3, 0, nil, GetPicture(130), GetPicture(129), myRGBCol, blackColor);
{Create a ToolBar with 8, 22 x 22 cells, inset of 3 (hence 16 x 16 icons) }

	if (Handle(myTB) = nil) or (Handle(myTBII) = nil) then
		begin
			SysBeep(5);
			ExitToShell;
{TBCreate failed}
		end;
	err := TBPlotIcon(myTB, 1, -3983, ttNone, aVerticalCenter + aHorizontalCenter);
	err := TBPlotIcon(myTB, 2, -3982, ttNone, aVerticalCenter + aHorizontalCenter);
	err := TBPlotIcon(myTB, 3, -3981, ttNone, aVerticalCenter + aHorizontalCenter);
	err := TBPlotIcon(myTB, 4, -3976, ttNone, aVerticalCenter + aHorizontalCenter);
{We plot some system icons into the first 4 cells of myTB}

	err := TBPlotIcon(myTBII, 1, -3982, ttNone, aVerticalCenter + aHorizontalCenter);
	err := TBPlotIcon(myTBII, 2, -3974, ttNone, aVerticalCenter + aHorizontalCenter);
	err := TBPlotIcon(myTBII, 3, -3973, ttNone, aVerticalCenter + aHorizontalCenter);
	err := TBPlotIcon(myTBII, 4, -3979, ttNone, aVerticalCenter + aHorizontalCenter);
{We plot some system icons into the first 4 cells of myTBII}

	cellsArray[1] := -3982;
	cellsArray[2] := -3974;
	cellsArray[3] := -3973;
	cellsArray[4] := -3979;
{We remember the icon ID's we plotted into myTBII}


	TBDraw(myTB);
	TBDraw(myTBII);
{Draw the ToolBars. No need to call SetPort as TBDraw takes care of everything internally}

	SetPort(myWindow);
	MoveTo(0, 32);
	LineTo(100, 32);
	MoveTo(100, 0);
	LineTo(100, 32);
	LineTo(240, 32);
	MoveTo(0, 150);
	LineTo(240, 150);
	MoveTo(0, 99);
	LineTo(240, 99);
	MoveTo(0, 132);
	LineTo(240, 132);
	MoveTo(10, 170);
	DrawString('Click here to move and grow myTB');
{Draw nice borders around the ToolBars}

	InitCursor;
	repeat
		dummy := WaitNextEvent(everyEvent, gEvt, 60, nil);
		GetMouse(mouseLoc);	{GetMouse returns the mouse location in LOCAL coordinates which is what we want}
		if gEvt.what = mouseDown then
			begin
				thePart := FindWindow(gEvt.where, theWindow);

				if thePart = inDrag then
					DragWindow(myWindow, gEvt.where, screenBits.bounds);

				if thePart = inGoAway then
					endIt := TrackGoAway(myWindow, gEvt.where);

				theCell := TBClick(myTB, mouseLoc);

{Call TBClick whenever there is a mouseDown event in}
{the window holding the toolbars. It would be redundant}
{to check if the click is in the ToolBars as TBClick already}
{does this}

				if (theCell > 2) then
					begin
						TBPlotPict(myTB, theCell, GetPicture(130));
						TBUpdateCell(myTB, theCell);
{This demonstrates one way to clear a cell.}
{All we do is plot an empty cell PICT into the}
{old cell.}

					end;

				theCell := TBClick(myTBII, mouseLoc);

{Upon return, theCell will hold the cell number clicked and released}
{in. If it's -1, this means the user released the mouse button outside}
{a cell or clicked in the scroll area or did not click in any part}
{of the ToolBar}

				if mouseLoc.v > 150 then
					begin
{This is just a demo to show TBGrowBar. You would call this}
{after the user has released the mouse following a window }
{re-size. We will not go into that for simplicity. We will just}
{Move and Grow the ToolBar myTB if the mouseLoc.v is}
{greater than 150}

						SetRect(ddomrect, 0, 100, 240, 122);	{New rect for the bar}
						SetRect(ddomrectII, 0, 122, 240, 132);	{New rect for the scroll area}

						TBGrowBar(myTB, ddomRect, ddomrectII);

{TBGrowBar takes care of all internal re-calculations. The new}
{Bar and Scroll area does not need to have the same width etc.}

						SetRect(ddomrect, 0, 0, 100, 22);	{Rect for the bar}
						SetRect(ddomrectII, 0, 22, 100, 32);	{Rect for the scroll area}
						ForeColor(whiteColor);
						PaintRect(ddomrect);	{Clear the old bar rect}
						Paintrect(ddomRectII);	{Clear the old scroll area. TBGrowBar does not do this for you}
						ForeColor(blackColor);
						MoveTo(27, 20);
						DrawString('For rent');	{Inside joke}

						TBDraw(myTB);

{Draw the bar in new location}

					end;
			end;

		if gEvt.what = updateEvt then
			begin
				BeginUpdate(myWindow);
				MoveTo(0, 32);
				LineTo(100, 32);
				MoveTo(100, 0);
				LineTo(100, 32);
				LineTo(240, 32);
				MoveTo(0, 150);
				LineTo(240, 150);
				MoveTo(0, 99);
				LineTo(240, 99);
				MoveTo(0, 132);
				LineTo(240, 132);
				TBDraw(myTB);
				TBDraw(myTBII);
				EndUpdate(myWindow);
			end;

{The following does the dimming when the mouse goes over}
{any occupied cell in myTBII. Nice and small piece of code eh?}

		theCell := TBPttoCell(myTBII, mouseLoc);

{We first get which cell the mouse is hovering over}

		if (theCell < 5) and (not dimmed) then
			begin
{ If we get here, that means the mouse is in an occupied cell}
{and it is not dimmed}
				TBClearCell(myTBII, theCell);
{We first clear the cell. TBClearCell just draws the background color passed}
{to TBCreate into a cell.}
				myRGBCol.red := 40000;
				myRGBCol.green := 40000;
				myRGBCol.blue := 40000;
{We set the masking color}
				TBDimPict(myTBII, theCell, nil, cellsArray[theCell], aVerticalCenter + aHorizontalCenter, myRGBCol, false);
				TBUpdateCell(myTBII, theCell);
{We dim the cell and call TBUpdateCell to draw the change to myWindow}
				dimmed := true;
				curDimcell := theCell;
{Set dim to true and curDimcell to theCell}
			end
		else if (theCell <> curDimcell) and (dimmed) then
			begin
{ If we got here, this means that the mouse is no longer}
{over the current dimmed cell and that the cell is still dimmed.}
{We therefore have to restore it}
				TBClearCell(myTBII, curDimcell);
{We first clear the cell again.}
				err := TBPlotIcon(myTBII, curDimcell, cellsArray[curDimcell], ttNone, aVerticalCenter + aHorizontalCenter);
				TBUpdateCell(myTBII, curDimcell);
{We then re-plot the icon using our array}
				dimmed := false;
				curDimcell := -1;
{Update curDimmcell and dimmed}
			end;
	until endit;

{That's it! Simple huh?}
end.