/************************************************************************************
 * AsmRoutines.c
 *
 * CheeseToast by Jim Bumgardner
 *
 ************************************************************************************/

#include "CToast.h"

extern SpriteDef sDef[];
extern SpriteInstance *sTable;
extern long		gScreenRowBytes,gVideoRowBytes;
extern Ptr		gScreenMem,gVideoMem;
extern Rect		gPlayRect,gOffscreenRect;

void StandardSpriteDraw(register SpriteInstance *sp)
{
	register Ptr	spritePtr,scrnPtr;
	Ptr				maskPtr;
	register short	j;
	register long	rowBytesOffset;
	register Point	loc;

	sp->update = true;

	loc = sp->pos;

	rowBytesOffset = gScreenRowBytes - IconWidth;

	scrnPtr = gScreenMem + (loc.v*gScreenRowBytes + loc.h);
	spritePtr = sp->saveMapPtr->saveMap;
#if DEBUGGING
	if (spritePtr == NULL)
		DebugStr("\pNull Save Map!");
#endif
	// Copy
	asm {
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		add.l	rowBytesOffset,scrnPtr
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		add.l	rowBytesOffset,scrnPtr
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		add.l	rowBytesOffset,scrnPtr
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		add.l	rowBytesOffset,scrnPtr
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		add.l	rowBytesOffset,scrnPtr
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		add.l	rowBytesOffset,scrnPtr
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		add.l	rowBytesOffset,scrnPtr
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		add.l	rowBytesOffset,scrnPtr
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		add.l	rowBytesOffset,scrnPtr
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		add.l	rowBytesOffset,scrnPtr
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		add.l	rowBytesOffset,scrnPtr
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		add.l	rowBytesOffset,scrnPtr
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		add.l	rowBytesOffset,scrnPtr
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		add.l	rowBytesOffset,scrnPtr
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		add.l	rowBytesOffset,scrnPtr
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		add.l	rowBytesOffset,scrnPtr
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		add.l	rowBytesOffset,scrnPtr
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		add.l	rowBytesOffset,scrnPtr
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		add.l	rowBytesOffset,scrnPtr
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		add.l	rowBytesOffset,scrnPtr
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		add.l	rowBytesOffset,scrnPtr
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		add.l	rowBytesOffset,scrnPtr
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		add.l	rowBytesOffset,scrnPtr
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		add.l	rowBytesOffset,scrnPtr
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		add.l	rowBytesOffset,scrnPtr
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		add.l	rowBytesOffset,scrnPtr
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		add.l	rowBytesOffset,scrnPtr
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		add.l	rowBytesOffset,scrnPtr
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		add.l	rowBytesOffset,scrnPtr
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		add.l	rowBytesOffset,scrnPtr
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		add.l	rowBytesOffset,scrnPtr
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr)+, (spritePtr)+
		move.l	(scrnPtr), (spritePtr)
	}

	spritePtr = sDef[sp->type].colorMaps + AniFrameIndex(sp->aniState);
	maskPtr = sDef[sp->type].maskMaps + AniFrameIndex(sp->aniState);
	scrnPtr = gScreenMem + (loc.v*gScreenRowBytes + loc.h);
	asm {
		move.l	maskPtr, a0
	}
	for (j = 0; j < IconWidth; ++j) {
		asm {
			move.l	(scrnPtr), d0
			move.l	(spritePtr)+, d2
			move.l	(a0)+,d1
			eor.l	d0,d2
			and.l	d2,d1
			eor.l	d1,d0
			move.l	d0,(scrnPtr)+

			move.l	(scrnPtr), d0
			move.l	(spritePtr)+, d2
			move.l	(a0)+,d1
			eor.l	d0,d2
			and.l	d2,d1
			eor.l	d1,d0
			move.l	d0,(scrnPtr)+

			move.l	(scrnPtr), d0
			move.l	(spritePtr)+, d2
			move.l	(a0)+,d1
			eor.l	d0,d2
			and.l	d2,d1
			eor.l	d1,d0
			move.l	d0,(scrnPtr)+

			move.l	(scrnPtr), d0
			move.l	(spritePtr)+, d2
			move.l	(a0)+,d1
			eor.l	d0,d2
			and.l	d2,d1
			eor.l	d1,d0
			move.l	d0,(scrnPtr)+

			move.l	(scrnPtr), d0
			move.l	(spritePtr)+, d2
			move.l	(a0)+,d1
			eor.l	d0,d2
			and.l	d2,d1
			eor.l	d1,d0
			move.l	d0,(scrnPtr)+

			move.l	(scrnPtr), d0
			move.l	(spritePtr)+, d2
			move.l	(a0)+,d1
			eor.l	d0,d2
			and.l	d2,d1
			eor.l	d1,d0
			move.l	d0,(scrnPtr)+

			move.l	(scrnPtr), d0
			move.l	(spritePtr)+, d2
			move.l	(a0)+,d1
			eor.l	d0,d2
			and.l	d2,d1
			eor.l	d1,d0
			move.l	d0,(scrnPtr)+

			move.l	(scrnPtr), d0
			move.l	(spritePtr)+, d2
			move.l	(a0)+,d1
			eor.l	d0,d2
			and.l	d2,d1
			eor.l	d1,d0
			move.l	d0,(scrnPtr)+

			add.l	rowBytesOffset,scrnPtr
		}
	}
}

void StandardSpriteErase(register SpriteInstance *sp)
{
	register Ptr	scrnPtr,spritePtr;
	register long rowBytesOffset;

	register Point	loc;

	sp->update = true;

	loc = sp->pos;

	scrnPtr = gScreenMem + (loc.v*gScreenRowBytes + loc.h);
	spritePtr = sp->saveMapPtr->saveMap;
#if DEBUGGING
	if (spritePtr == NULL)
		DebugStr("\pNull Save Map!");
#endif

	rowBytesOffset = gScreenRowBytes - IconWidth;

	asm {
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		add.l	rowBytesOffset,scrnPtr

		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		add.l	rowBytesOffset,scrnPtr

		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		add.l	rowBytesOffset,scrnPtr

		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		add.l	rowBytesOffset,scrnPtr

		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		add.l	rowBytesOffset,scrnPtr

		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		add.l	rowBytesOffset,scrnPtr

		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		add.l	rowBytesOffset,scrnPtr

		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		add.l	rowBytesOffset,scrnPtr

		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		add.l	rowBytesOffset,scrnPtr

		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		add.l	rowBytesOffset,scrnPtr

		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		add.l	rowBytesOffset,scrnPtr

		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		add.l	rowBytesOffset,scrnPtr

		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		add.l	rowBytesOffset,scrnPtr

		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		add.l	rowBytesOffset,scrnPtr

		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		add.l	rowBytesOffset,scrnPtr

		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		add.l	rowBytesOffset,scrnPtr

		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		add.l	rowBytesOffset,scrnPtr

		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		add.l	rowBytesOffset,scrnPtr

		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		add.l	rowBytesOffset,scrnPtr

		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		add.l	rowBytesOffset,scrnPtr

		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		add.l	rowBytesOffset,scrnPtr

		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		add.l	rowBytesOffset,scrnPtr

		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		add.l	rowBytesOffset,scrnPtr

		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		add.l	rowBytesOffset,scrnPtr

		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		add.l	rowBytesOffset,scrnPtr

		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		add.l	rowBytesOffset,scrnPtr

		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		add.l	rowBytesOffset,scrnPtr

		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		add.l	rowBytesOffset,scrnPtr

		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		add.l	rowBytesOffset,scrnPtr

		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		add.l	rowBytesOffset,scrnPtr

		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		add.l	rowBytesOffset,scrnPtr

		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr)+, (scrnPtr)+
		move.l	(spritePtr), (scrnPtr)
	}
}



void BulletDraw(register SpriteInstance *sp)
{
	register Ptr	spritePtr,scrnPtr;
	register long	rowBytesOffset;
	register Point	loc;

	sp->update = true;

	loc = sp->pos;

	rowBytesOffset = gScreenRowBytes - BulletWidth;

	scrnPtr = gScreenMem + (loc.v*gScreenRowBytes + loc.h);
	spritePtr = sp->savePixel;

	// Copy
	asm {
		move.w	(scrnPtr)+, (spritePtr)+
		add.l	rowBytesOffset,scrnPtr
		move.w	(scrnPtr), (spritePtr)
	}

	scrnPtr = gScreenMem + (loc.v*gScreenRowBytes + loc.h);

	asm {
		clr.w	(scrnPtr)+
		add.l	rowBytesOffset,scrnPtr
		clr.w	(scrnPtr)
	}
}

void PhotonDraw(register SpriteInstance *sp)
{
	register Ptr	spritePtr,scrnPtr;
	register long	rowBytesOffset;
	register Point	loc;

	sp->update = true;

	loc = sp->pos;

	rowBytesOffset = gScreenRowBytes - BulletWidth;

	scrnPtr = gScreenMem + (loc.v*gScreenRowBytes + loc.h);
	spritePtr = sp->savePixel;

	// Copy
	asm {
		move.w	(scrnPtr)+, (spritePtr)+
		add.l	rowBytesOffset,scrnPtr
		move.w	(scrnPtr), (spritePtr)
	}

	scrnPtr = gScreenMem + (loc.v*gScreenRowBytes + loc.h);

	asm {
		move.w	#0x0505,(scrnPtr)+
		add.l	rowBytesOffset,scrnPtr
		move.w	#0x0505,(scrnPtr)
	}
}

void BulletErase(register SpriteInstance *sp)
{
	register Ptr	scrnPtr,spritePtr;
	register long	rowBytesOffset;

	register Point	loc;

	sp->update = true;

	loc = sp->pos;

	scrnPtr = gScreenMem + (loc.v*gScreenRowBytes + loc.h);
	spritePtr = sp->savePixel;
	rowBytesOffset = gScreenRowBytes - BulletWidth;

	asm {
		move.w	(spritePtr)+, (scrnPtr)+
		add.l	rowBytesOffset,scrnPtr
		move.w	(spritePtr), (scrnPtr)
	}
}

void SparkDraw(register SpriteInstance *sp)
{
	register Ptr	scrnPtr;
	register char	color;
	register Point	loc;

	sp->update = true;

	loc = sp->pos;

	color = sp->param1;
	scrnPtr = gScreenMem + (loc.v*gScreenRowBytes + loc.h);
	sp->savePixel[0] = *scrnPtr;
	*scrnPtr = color;
}

void SparkErase(register SpriteInstance *sp)
{
	register Ptr	scrnPtr;
	register Point	loc;

	sp->update = true;

	loc = sp->pos;

	scrnPtr = gScreenMem + (loc.v*gScreenRowBytes + loc.h);
	*scrnPtr = sp->savePixel[0];
}

void MyCopyBits(void)
{
	register Ptr	scrnPtr, vidPtr;
	register long	vidRowBytesOffset,scrnRowBytesOffset;
	register short	y,x;
	char			mmode;

	scrnPtr = gScreenMem;
	scrnPtr += IconWidth + (gScreenRowBytes << 5);
	scrnRowBytesOffset = gScreenRowBytes - 640;

	vidPtr = gVideoMem;
	vidRowBytesOffset = gVideoRowBytes - 640;

	mmode = 1;
	SwapMMUMode(&mmode);
	y = 480;
	while (y--) {
		asm {
			// 80 Occurences
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			
			// 80 Occurences
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			move.l	(scrnPtr)+,(vidPtr)+
			
			add.l	vidRowBytesOffset, vidPtr
			add.l	scrnRowBytesOffset, scrnPtr
		}
	}
	SwapMMUMode(&mmode);
}

void MyCopyRect(register Rect *r)
{
	register Ptr	scrnPtr, vidPtr;
	register long	vidRowBytesOffset,scrnRowBytesOffset;
	register short	y,x;
	char			mmode;

	scrnPtr = gScreenMem;
	scrnPtr += r->left + (gScreenRowBytes *r->top);
	scrnRowBytesOffset = gScreenRowBytes - (r->right - r->left);

	vidPtr = gVideoMem;
	vidPtr += (r->left-32) + ((r->top-32)*gVideoRowBytes);
	vidRowBytesOffset = gVideoRowBytes - (r->right - r->left);

	mmode = 1;
	SwapMMUMode(&mmode);
	y = r->bottom - r->top;
	while (y--) {
		x = r->right - r->left;
		while (x--) {
			asm {
				move.b	(scrnPtr)+,(vidPtr)+
			}
		}
		scrnPtr += scrnRowBytesOffset;
		vidPtr += vidRowBytesOffset;
	}
	SwapMMUMode(&mmode);
}