#include <QDOffscreen.h>
#include <Video.h>

GammaTblPtr      newGammaTable;
GammaTblPtr      savedGammaTable;
GDHandle         mainDevice;
CTabHandle       mainDeviceColors;
VDGammaRecord    newGamma;
VDSetEntryRecord setEntriesRec;
unsigned char    *newTable;
unsigned char    *savedTable;
VDGammaRecord    currentGamma;
GammaTblPtr      currentGammaTable;

pascal short VideoStatus(short refNum, short code, Ptr param);

void GammaFadeOut(void)
{
	QDErr	error;
	short            count;
	long             fadeAmount;
	short            channelIndex;
	Ptr				 csPtr;

	mainDevice = GetMainDevice ();

	/* Grab the main devices gamma table; VideoStatus in Sample.a */
	error = VideoStatus( (**mainDevice).gdRefNum, cscGetGamma,
			(Ptr)&currentGamma );

	/* Grab a pointer to the main devices gamma table */
	currentGammaTable = (GammaTblPtr)currentGamma.csGTable;

	/* Alloc mem for new gamma table */
	savedGammaTable = (GammaTblPtr)NewPtr( sizeof (GammaTbl) +
			currentGammaTable->gDataCnt * currentGammaTable->gChanCnt +
			currentGammaTable->gFormulaSize );

	/* Copy main devices gamma into new gamma except for table itself */
	BlockMove( (Ptr)currentGammaTable, (Ptr)savedGammaTable,
			sizeof (GammaTbl) + currentGammaTable->gDataCnt *
			currentGammaTable->gChanCnt +
			currentGammaTable->gFormulaSize );

	/* Alloc mem for new gamma table */
	newGammaTable = (GammaTblPtr)NewPtr( sizeof (GammaTbl) +
			currentGammaTable->gDataCnt * currentGammaTable->gChanCnt +
			currentGammaTable->gFormulaSize );

	/* Copy main devices gamma into new gamma except for table itself */
	BlockMove( (Ptr)savedGammaTable, (Ptr)newGammaTable,
			sizeof (GammaTbl) );

	/* Fade out the screen */
	for (fadeAmount = 100; fadeAmount >= 0; fadeAmount -= 4)
	{
		/* Get pointers to the actual tables */
		newTable = (unsigned char *)&newGammaTable->gFormulaData +
				newGammaTable->gFormulaSize;
		savedTable = (unsigned char *)&savedGammaTable->gFormulaData +
				savedGammaTable->gFormulaSize;

		/* For each channel in the table, fade it */
		for (channelIndex = 0; channelIndex < savedGammaTable->gChanCnt; ++channelIndex)
		{
			/* For each entry in each table channel, fade it */
			for (count = 0; count < savedGammaTable->gDataCnt; count++)
				newTable[count] = savedTable[count] * fadeAmount / 100L;

			/* Point to the next channels */
			newTable += newGammaTable->gDataCnt;
			savedTable += savedGammaTable->gDataCnt;
		}

		/* Write the new gamma table to the main device */
		newGamma.csGTable = (Ptr)newGammaTable;
		csPtr = (Ptr) &newGamma;
		error = Control( (**mainDevice).gdRefNum, cscSetGamma, (Ptr)&csPtr );

		/* Force the main device to use the new gamma table */
		mainDeviceColors = (**(**mainDevice).gdPMap).pmTable;
		setEntriesRec.csTable = (ColorSpec *)&(**mainDeviceColors).ctTable;
		setEntriesRec.csStart = 0;
		setEntriesRec.csCount = (**mainDeviceColors).ctSize;
		csPtr = (Ptr) &setEntriesRec;
		error = Control ((**mainDevice).gdRefNum, cscSetEntries,
				(Ptr) &csPtr);
	}
}

void GammaFadeIn(void)
{
	long             fadeAmount;
	unsigned char    *newTable;
	unsigned char    *savedTable;
	short            count;
	short            channelIndex;
	VDGammaRecord    newGamma;
	Ptr				 csPtr;
	QDErr			error;
	VDSetEntryRecord setEntriesRec;

	/* Fade in the screen */
	for (fadeAmount = 0; fadeAmount <= 100; fadeAmount += 4)
	{
		/* Get pointers to the actual tables */
		newTable = (unsigned char *)&newGammaTable->gFormulaData +
				newGammaTable->gFormulaSize;
		savedTable = (unsigned char *)&savedGammaTable->gFormulaData +
				savedGammaTable->gFormulaSize;

		/* For each channel in the table, fade it */
		for (channelIndex = 0; channelIndex < savedGammaTable->gChanCnt; ++channelIndex)
		{
			/* For each entry in each table channel, fade it */
			for (count = 0; count < savedGammaTable->gDataCnt; count++)
				newTable[count] = savedTable[count] * fadeAmount / 100L;

			/* Point to the next channels */
			newTable += newGammaTable->gDataCnt;
			savedTable += savedGammaTable->gDataCnt;
		}

		/* Write the new gamma table to the main device */
		newGamma.csGTable = (Ptr) newGammaTable;
		csPtr = (Ptr) &newGamma;
		error = Control ((**mainDevice).gdRefNum, cscSetGamma, (Ptr) &csPtr);

		/* Force the main device to use the new gamma table */
		mainDeviceColors = (**(**mainDevice).gdPMap).pmTable;
		setEntriesRec.csTable = (ColorSpec *)&(**mainDeviceColors).ctTable;
		setEntriesRec.csStart = 0;
		setEntriesRec.csCount = (**mainDeviceColors).ctSize;
		csPtr = (Ptr) &setEntriesRec;
		error = Control ((**mainDevice).gdRefNum, cscSetEntries,
				(Ptr) &csPtr);
	}

	DisposPtr( (Ptr)newGammaTable );
	DisposPtr( (Ptr)savedGammaTable );
}
