/**********************************************************************\

File:		Caste wipe R-L.c

Purpose:	Graphic effect from offscreen bitmap to main window (on
			screen).  See comments below for more description.


MSG Demo -- graphic effects demonstration program
Copyright (C) 1992-3 Mark Pilgrim & Dave Blumenthal

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program in a file named "GNU General Public License".
If not, write to the Free Software Foundation, 675 Mass Ave,
Cambridge, MA 02139, USA.

\**********************************************************************/

#include "msg timing.h"

#define		gap				14       /* width of strip */
#define CorrectTime 1

void CasteWipeRL(GrafPtr, GrafPtr, int, int);

/* This takes a strip (starting with the leftmost strip, moving right) and
   copies it into all the strips starting at the right and moving left until
   its in the right place. */
   
void CasteWipeRL(GrafPtr sourceGrafPtr, GrafPtr destGrafPtr, int theWindowHeight, int theWindowWidth)
{
	int		srcx, barpos;
	Rect	src, dest;
	Boolean	everyOther;
	
	everyOther=FALSE;
	src.top = 0;                       /* constant */
	src.bottom = theWindowHeight;   /* constant */
	
	for(srcx = 0; srcx < theWindowWidth; srcx += gap)
	{
		for(barpos = 0; barpos + gap < theWindowWidth; barpos += gap);
		for(; barpos >= srcx; barpos -= gap)
		{
			StartTiming();
			src.left = srcx;
			src.right = srcx + gap;
			dest = src;
			dest.left = barpos;
			dest.right = barpos + gap;
			CopyBits(&(sourceGrafPtr->portBits), &(destGrafPtr->portBits),
					&src, &dest, 0, 0L);
			if (everyOther)                        /* really, we need time */
				TimeCorrection(CorrectTime);       /* correction 0.5, but  */
			everyOther=!everyOther;                /* this will do (gag)   */
		}
	}
}