/**********************************************************************\

File:		Circle serendipity.c

Purpose:	Graphic effect from offscreen bitmap to main window (on
			screen).  See comments below for more description.


MSG Demo -- graphic effects demonstration program
Copyright (C) 1992-3 Mark Pilgrim & Dave Blumenthal

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program in a file named "GNU General Public License".
If not, write to the Free Software Foundation, 675 Mass Ave,
Cambridge, MA 02139, USA.

\**********************************************************************/

#include "msg timing.h"

#define	gap			7
#define CorrectTime 2

void CircleSerendipity(GrafPtr, GrafPtr, int, int);

/* I haven't the slightest idea why this works.  Hence the name.  -MP */

void CircleSerendipity(GrafPtr sourceGrafPtr, GrafPtr destGrafPtr, int theWindowHeight, int theWindowWidth)
{
	Rect		theRect;
	Rect		source;
	RgnHandle	curregion;
	Point		zeropoint;
	
	source.top=source.left=0;
	source.right=theWindowWidth;
	source.bottom=theWindowHeight;
	
	theRect=source;
	theRect.top-=theWindowHeight;
	OffsetRect(&theRect,0,-theWindowHeight);
		
	curregion=NewRgn();
	SetEmptyRgn(curregion);
	OpenRgn();
		FrameOval(&theRect);
	CloseRgn(curregion);
	zeropoint.v=theWindowHeight;
	zeropoint.h=0;
	do
	{
		StartTiming();
		CopyBits(&(sourceGrafPtr->portBits), &(destGrafPtr->portBits),
				&source, &source, 0, curregion);
		OffsetRgn(curregion, 0, gap);
		TimeCorrection(CorrectTime);
	}
	while (!(PtInRgn(zeropoint, curregion)));

	CopyBits(&(sourceGrafPtr->portBits), &(destGrafPtr->portBits),
			&source, &source, 0, 0L);
	
	DisposeRgn(curregion);
}
