/**********************************************************************\

File:		Full scroll L-R.c

Purpose:	Graphic effect from offscreen bitmap to main window (on
			screen).  See comments below for more description.


MSG Demo -- graphic effects demonstration program
Copyright (C) 1992-3 Mark Pilgrim & Dave Blumenthal

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program in a file named "GNU General Public License".
If not, write to the Free Software Foundation, 675 Mass Ave,
Cambridge, MA 02139, USA.

\**********************************************************************/

#include "msg timing.h"

#define		BoxSize		20
#define CorrectTime 3

void FullScrollLR(GrafPtr, GrafPtr, int, int);

/* Take the whole screen - the righthand strip; move it into the whole screen
   shifted right by BoxSize; take the righthand strip of the source window and
   move it into the lefthand strip of the dest.  */
   
void FullScrollLR(GrafPtr sourceGrafPtr, GrafPtr destGrafPtr, int theWindowHeight, int theWindowWidth)
{
	int			x, y;
	Rect		theRect, dest;
	Rect		scrollsource, scrolldest;
	
	scrollsource=destGrafPtr->portRect;
	scrollsource.right-=BoxSize;              /* whole screen minus righthand strip */
	scrolldest = scrollsource;
	OffsetRect(&scrolldest, BoxSize, 0);      /* whole screen shifted +BoxSize */
	
	dest = destGrafPtr->portRect;
	dest.right=BoxSize;                       /* lefthand strip */
	
	theRect.top=0;
	theRect.bottom=theWindowHeight;
	theRect.left=theWindowWidth-BoxSize;
	theRect.right=theWindowWidth;          /* source strip */
	
	for(x = theWindowWidth - BoxSize; x >= 0; x -= BoxSize)
	{
		StartTiming();
		CopyBits(&(destGrafPtr->portBits), &(destGrafPtr->portBits),
				&scrollsource, &scrolldest, 0, 0L);
		CopyBits(&(sourceGrafPtr->portBits), &(destGrafPtr->portBits),
				&theRect, &dest, 0, 0L);
		theRect.right-=BoxSize;
		theRect.left-=BoxSize;
		TimeCorrection(CorrectTime);
	}
}