/**********************************************************************\

File:		Ripple wipe.c

Purpose:	Graphic effect from offscreen bitmap to main window (on
			screen).  See comments below for more description.


MSG Demo -- graphic effects demonstration program
Copyright (C) 1992-3 Mark Pilgrim & Dave Blumenthal

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program in a file named "GNU General Public License".
If not, write to the Free Software Foundation, 675 Mass Ave,
Cambridge, MA 02139, USA.

\**********************************************************************/

#include "msg timing.h"

#define		BigRippleSize	52
#define		gap				8
#define CorrectTime 1

void RippleWipe(GrafPtr, GrafPtr, int, int);

void RippleWipe(GrafPtr sourceGrafPtr, GrafPtr destGrafPtr, int theWindowHeight, int theWindowWidth)
{
	int		bigy, littley, barpos;
	Rect	src, dest;
	
	src.left = 0;
	src.right = theWindowWidth;
	
	for(bigy = 0; bigy < theWindowHeight; bigy += BigRippleSize)
	{
		for(littley = bigy; littley < bigy + BigRippleSize; littley += gap)
		{
			for(barpos = bigy; barpos + gap < bigy + BigRippleSize; barpos += gap);
			for(; barpos >= littley; barpos -= gap)
			{
				StartTiming();
				src.top = littley;
				src.bottom = littley + gap;
				dest = src;
				dest.top = barpos;
				dest.bottom = barpos + gap;
				CopyBits(&(sourceGrafPtr->portBits), &(destGrafPtr->portBits),
						&src, &dest, 0, 0L);
				TimeCorrection(CorrectTime);
			}
		}
	}
}