/**********************************************************************\

File:		Skipaline L-R.c

Purpose:	Graphic effect from offscreen bitmap to main window (on
			screen).  See comments below for more description.


MSG Demo -- graphic effects demonstration program
Copyright (C) 1992-3 Mark Pilgrim & Dave Blumenthal

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program in a file named "GNU General Public License".
If not, write to the Free Software Foundation, 675 Mass Ave,
Cambridge, MA 02139, USA.

\**********************************************************************/

#include "msg timing.h"

#define CorrectTime 1

void SkipalineLR(GrafPtr, GrafPtr, int, int);

/* Copy even-numbered columns starting at the left and moving right, and odd-
   numbered columns starting at the right and moving left.  */
   
void SkipalineLR(GrafPtr sourceGrafPtr, GrafPtr destGrafPtr, int theWindowHeight, int theWindowWidth)
{
	Rect		thisone,thatone;
	Boolean		everyOther=FALSE;
	
	thisone.left=thisone.top=thatone.top=0;
	thisone.bottom=thatone.bottom=theWindowHeight;
	thisone.right=1;
	thatone.right=theWindowWidth;
	thatone.left=theWindowWidth-1;
		
	while (thisone.left<theWindowWidth)
	{
		StartTiming();
		CopyBits(&(sourceGrafPtr->portBits), &(destGrafPtr->portBits),
			&thisone, &thisone, 0, 0L);
		CopyBits(&(sourceGrafPtr->portBits), &(destGrafPtr->portBits),
			&thatone, &thatone, 0, 0L);
		thisone.left+=2;      /* left column moves right by 2 */
		thisone.right+=2;
		thatone.left-=2;      /* right column moves left by 2 */
		thatone.right-=2;
		if (everyOther)
			TimeCorrection(CorrectTime);
		everyOther=!everyOther;
	}
}