/*******************************************************************************
 * Copyright  1992-1993 Mark Pilgrim                                          *
 *                                                                             *
 * This file is provided as is, and may be freely distributed unaltered.  This *
 * message must accompany any copy of this file.  This file may be used or     *
 * modified for use for a non-commercial product provided that appropriate     *
 * credit is given to the author named above.                                  *
 * Commercial use of this source code is prohibited.                           *
 ******************************************************************************/

#include "msg misc.h"
#include "msg timing.h"

#define		BoxSize		20
#define CorrectTime 3

void FullScrollLR(GrafPtr);

/* Take the whole screen - the righthand strip; move it into the whole screen
   shifted right by BoxSize; take the righthand strip of the source window and
   move it into the lefthand strip of the dest.  */
   
void FullScrollLR(GrafPtr sourceGrafPtr)
{
	int			x, y;
	Rect		theRect, dest;
	Rect		scrollsource, scrolldest;
	
	scrollsource=gMainWindow->portRect;
	scrollsource.right-=BoxSize;              /* whole screen minus righthand strip */
	scrolldest = scrollsource;
	OffsetRect(&scrolldest, BoxSize, 0);      /* whole screen shifted +BoxSize */
	
	dest = gMainWindow->portRect;
	dest.right=BoxSize;                       /* lefthand strip */
	
	theRect.top=0;
	theRect.bottom=MAIN_WINDOW_HEIGHT;
	theRect.left=MAIN_WINDOW_WIDTH-BoxSize;
	theRect.right=MAIN_WINDOW_WIDTH;          /* source strip */
	
	for(x = MAIN_WINDOW_WIDTH - BoxSize; x >= 0; x -= BoxSize)
	{
		StartTiming();
		CopyBits(&(gMainWindow->portBits), &(gMainWindow->portBits),
				&scrollsource, &scrolldest, 0, 0L);
		CopyBits(&(sourceGrafPtr->portBits), &(gMainWindow->portBits),
				&theRect, &dest, 0, 0L);
		theRect.right-=BoxSize;
		theRect.left-=BoxSize;
		TimeCorrection(CorrectTime);
	}
}