/*******************************************************************************
 * Copywrite  1992-1993 David S. Blumenthal                                   *
 *                                                                             *
 * This file is provided as is, and may be freely distributed unaltered.  This *
 * message must accompany any copy of this file.  This file may be used or     *
 * modified for use for a non-commercial product provided that appropriate     *
 * credit is given to the author named above.                                  *
 * Commercial use of this source code is prohibited.                           *
 ******************************************************************************/

#include "msg misc.h"
#include "msg timing.h"

#define		BigRippleSize	52
#define		gap				8
#define CorrectTime 1

void RippleWipe(GrafPtr);

void RippleWipe(GrafPtr myGrafPtr)
{
	int		bigy, littley, barpos;
	Rect	src, dest;
	
	src.left = 0;
	src.right = MAIN_WINDOW_WIDTH;
	
	for(bigy = 0; bigy < MAIN_WINDOW_HEIGHT; bigy += BigRippleSize)
	{
		for(littley = bigy; littley < bigy + BigRippleSize; littley += gap)
		{
			for(barpos = bigy; barpos + gap < bigy + BigRippleSize; barpos += gap);
			for(; barpos >= littley; barpos -= gap)
			{
				StartTiming();
				src.top = littley;
				src.bottom = littley + gap;
				dest = src;
				dest.top = barpos;
				dest.bottom = barpos + gap;
				CopyBits(&(myGrafPtr->portBits), &(gMainWindow->portBits),
						&src, &dest, 0, 0L);
				TimeCorrection(CorrectTime);
			}
		}
	}
}