/*******************************************************************************
 * Copyright  1992-1993 Mark Pilgrim                                          *
 *                                                                             *
 * This file is provided as is, and may be freely distributed unaltered.  This *
 * message must accompany any copy of this file.  This file may be used or     *
 * modified for use for a non-commercial product provided that appropriate     *
 * credit is given to the author named above.                                  *
 * Commercial use of this source code is prohibited.                           *
 ******************************************************************************/

#include "msg misc.h"
#include "msg timing.h"

#define CorrectTime 1

void Skipaline(GrafPtr);

/* Copy even-numbered rows starting at the top and moving down, and copy odd-
   numbered rows starting at the bottom and moving up. */
   
void Skipaline(GrafPtr sourceGrafPtr)
{
	Rect		thisone,thatone;
	
	thisone.top=thisone.left=thatone.left=0;
	thisone.bottom=1;
	thatone.bottom=MAIN_WINDOW_HEIGHT;
	thatone.top=MAIN_WINDOW_HEIGHT-1;
	thisone.right=thatone.right=MAIN_WINDOW_WIDTH;
	
	while (thisone.top<MAIN_WINDOW_HEIGHT)
	{
		StartTiming();
		CopyBits(&(sourceGrafPtr->portBits), &(gMainWindow->portBits),
			&thisone, &thisone, 0, 0L);
		CopyBits(&(sourceGrafPtr->portBits), &(gMainWindow->portBits),
			&thatone, &thatone, 0, 0L);
		thisone.top+=2;             /* even row goes down by 2 */
		thisone.bottom+=2;
		thatone.top-=2;             /* odd row goes up by 2 */
		thatone.bottom-=2;
		TimeCorrection(CorrectTime);
	}
}